Index: palm/trunk/SCRIPTS/.csd.config.default
===================================================================
--- palm/trunk/SCRIPTS/.csd.config.default	(revision 4480)
+++ palm/trunk/SCRIPTS/.csd.config.default	(revision 4481)
@@ -15,5 +15,5 @@
 # PALM. If not, see <http://www.gnu.org/licenses/>.
 #
-# Copyright 1997-2018  Leibniz Universitaet Hannover
+# Copyright 1997-2020  Leibniz Universitaet Hannover
 #--------------------------------------------------------------------------------#
 #
Index: palm/trunk/SCRIPTS/batch_scp
===================================================================
--- palm/trunk/SCRIPTS/batch_scp	(revision 4480)
+++ palm/trunk/SCRIPTS/batch_scp	(revision 4481)
@@ -17,5 +17,5 @@
 # PALM. If not, see <http://www.gnu.org/licenses/>.
 #
-# Copyright 1997-2018  Leibniz Universitaet Hannover
+# Copyright 1997-2020  Leibniz Universitaet Hannover
 #--------------------------------------------------------------------------------#
 #
Index: palm/trunk/SCRIPTS/compile_tutorial
===================================================================
--- palm/trunk/SCRIPTS/compile_tutorial	(revision 4480)
+++ palm/trunk/SCRIPTS/compile_tutorial	(revision 4481)
@@ -15,5 +15,5 @@
 # PALM. If not, see <http://www.gnu.org/licenses/>.
 #
-# Copyright 1997-2018  Leibniz Universitaet Hannover
+# Copyright 1997-2020  Leibniz Universitaet Hannover
 #--------------------------------------------------------------------------------#
 #
Index: palm/trunk/SCRIPTS/document_changes
===================================================================
--- palm/trunk/SCRIPTS/document_changes	(revision 4480)
+++ palm/trunk/SCRIPTS/document_changes	(revision 4481)
@@ -25,4 +25,7 @@
 # -----------------
 # $Id$
+# Bugfix for copyright updates
+# 
+# 4370 2020-01-10 14:00:44Z raasch
 # script made bash compatible
 # 
@@ -204,10 +207,7 @@
        done <"$fn"
 
-       
-       
+
 #
 #--    check for updates of the copyright statement
-       found_update_year=false
-
        while read line 
        do 
@@ -216,30 +216,31 @@
           line_tmp2=""     
           line_tmp=${line:22:29}
-          line_tmp2=${line:2:15}
-          
-#           echo "$line_tmp $line_tmp2"
-          
-          if  [[ "$line_tmp" == "Leibniz Universitaet Hannover" && "$line_tmp2" == "Copyright 1997-" ]]
-          then
-          
-             year_in_file=${line:17:4}
-             if  [[ "$year_in_file" != "$current_year" ]]
+          line_tmp2=${line:2:10}
+
+          if  [[ "$line_tmp2" == "Copyright " ]]
+          then
+             year_in_file1=${line:12:4}
+             year_in_file2=${line:17:4}
+             institution=${line:22}
+
+             if  [[ "$year_in_file2" != "$current_year" ]]
              then
-      
                 printf "\r%$(tput cols)s" " "   
                 printf "\r  \e[1;33m*** Copyright update required in $fn\e[0m\n"
 
                 comment_char=${line:0:1}
-                found_update_year=true             
                 cp $fn $fn~
-                
+
+                (( count_updates = count_updates + 1 ))
+                sed -i "s/$comment_char Copyright .*$institution/$comment_char Copyright $year_in_file1-$current_year $institution/" $fn
+
              fi
           fi
-       
+
        done <"$fn"
-         
+
        printf "\r%$(tput cols)s" " "   
        printf "\r\e[1m  *** Searched files: $count_files. Comments found: $count_changes. Copyright updates found: $count_updates\e[0m"
-       
+
 #
 #--    move comments from current revisions to former revisions
@@ -252,7 +253,5 @@
 #--       remove leading \n characters in string
           comments=${comments:2}
- 
- 
-          
+
 #
 #--       fix old time stamp
@@ -267,5 +266,5 @@
           (( line_stop = line_stop + 2 ))
           sed -i "${line_stop}i$comments" $fn
-          
+
 
 
@@ -279,15 +278,4 @@
        fi
 
-#
-#--    move comments from current revisions to former revisions
-       if [[ "$found_update_year" == true ]]
-       then
-
-          (( count_updates = count_updates + 1 ))  
-          
-           sed -i "s/$comment_char Copyright 1997-.*Leibniz Universitaet Hannover/$comment_char Copyright 1997-$current_year Leibniz Universitaet Hannover/" $fn
-     
-       fi
-       
     done
 
Index: palm/trunk/SCRIPTS/generate_documentation
===================================================================
--- palm/trunk/SCRIPTS/generate_documentation	(revision 4480)
+++ palm/trunk/SCRIPTS/generate_documentation	(revision 4481)
@@ -14,5 +14,5 @@
 # PALM. If not, see <http://www.gnu.org/licenses/>.
 #
-# Copyright 1997-2018  Leibniz Universitaet Hannover
+# Copyright 1997-2020  Leibniz Universitaet Hannover
 #--------------------------------------------------------------------------------#
 #
Index: palm/trunk/SCRIPTS/inifor_script
===================================================================
--- palm/trunk/SCRIPTS/inifor_script	(revision 4480)
+++ palm/trunk/SCRIPTS/inifor_script	(revision 4481)
@@ -17,5 +17,5 @@
 # PALM. If not, see <http://www.gnu.org/licenses/>.
 #
-# Copyright 2017-2018  Leibniz Universitaet Hannover
+# Copyright 2017-2020  Leibniz Universitaet Hannover
 #--------------------------------------------------------------------------------#
 #
Index: palm/trunk/SCRIPTS/palm_csd
===================================================================
--- palm/trunk/SCRIPTS/palm_csd	(revision 4480)
+++ palm/trunk/SCRIPTS/palm_csd	(revision 4481)
@@ -15,5 +15,5 @@
 # PALM. If not, see <http://www.gnu.org/licenses/>.
 #
-# Copyright 1997-2018  Leibniz Universitaet Hannover
+# Copyright 1997-2020  Leibniz Universitaet Hannover
 #--------------------------------------------------------------------------------#
 #
Index: palm/trunk/SCRIPTS/palm_csd_files/palm_csd_canopy_generator.py
===================================================================
--- palm/trunk/SCRIPTS/palm_csd_files/palm_csd_canopy_generator.py	(revision 4480)
+++ palm/trunk/SCRIPTS/palm_csd_files/palm_csd_canopy_generator.py	(revision 4481)
@@ -15,5 +15,5 @@
 # PALM. If not, see <http://www.gnu.org/licenses/>.
 #
-# Copyright 1997-2018  Leibniz Universitaet Hannover
+# Copyright 1997-2020  Leibniz Universitaet Hannover
 #--------------------------------------------------------------------------------#
 #
Index: palm/trunk/SCRIPTS/palm_csd_files/palm_csd_netcdf_interface.py
===================================================================
--- palm/trunk/SCRIPTS/palm_csd_files/palm_csd_netcdf_interface.py	(revision 4480)
+++ palm/trunk/SCRIPTS/palm_csd_files/palm_csd_netcdf_interface.py	(revision 4481)
@@ -15,5 +15,5 @@
 # PALM. If not, see <http://www.gnu.org/licenses/>.
 #
-# Copyright 1997-2018  Leibniz Universitaet Hannover
+# Copyright 1997-2020  Leibniz Universitaet Hannover
 #--------------------------------------------------------------------------------#
 #
Index: palm/trunk/SCRIPTS/palm_csd_files/palm_csd_tools.py
===================================================================
--- palm/trunk/SCRIPTS/palm_csd_files/palm_csd_tools.py	(revision 4480)
+++ palm/trunk/SCRIPTS/palm_csd_files/palm_csd_tools.py	(revision 4481)
@@ -15,5 +15,5 @@
 # PALM. If not, see <http://www.gnu.org/licenses/>.
 #
-# Copyright 1997-2018  Leibniz Universitaet Hannover
+# Copyright 1997-2020  Leibniz Universitaet Hannover
 #--------------------------------------------------------------------------------#
 #
Index: palm/trunk/SCRIPTS/palm_find_lowest_available_error_number
===================================================================
--- palm/trunk/SCRIPTS/palm_find_lowest_available_error_number	(revision 4480)
+++ palm/trunk/SCRIPTS/palm_find_lowest_available_error_number	(revision 4481)
@@ -14,5 +14,5 @@
 # PALM. If not, see <http://www.gnu.org/licenses/>.
 #
-# Copyright 2018-2018  Leibniz Universitaet Hannover
+# Copyright 2018-2020  Leibniz Universitaet Hannover
 #------------------------------------------------------------------------------#
 #
Index: palm/trunk/SCRIPTS/palm_find_lowest_available_log_point_index
===================================================================
--- palm/trunk/SCRIPTS/palm_find_lowest_available_log_point_index	(revision 4480)
+++ palm/trunk/SCRIPTS/palm_find_lowest_available_log_point_index	(revision 4481)
@@ -14,5 +14,5 @@
 # PALM. If not, see <http://www.gnu.org/licenses/>.
 #
-# Copyright 2018-2018  Leibniz Universitaet Hannover
+# Copyright 2018-2020  Leibniz Universitaet Hannover
 #------------------------------------------------------------------------------#
 #
Index: palm/trunk/SCRIPTS/palm_gf
===================================================================
--- palm/trunk/SCRIPTS/palm_gf	(revision 4480)
+++ palm/trunk/SCRIPTS/palm_gf	(revision 4481)
@@ -15,5 +15,5 @@
 # PALM. If not, see <http://www.gnu.org/licenses/>.
 #
-# Copyright 1997-2018  Leibniz Universitaet Hannover
+# Copyright 1997-2020  Leibniz Universitaet Hannover
 #--------------------------------------------------------------------------------#
 #
Index: palm/trunk/SCRIPTS/palm_gf_files/palm_gf_tools.py
===================================================================
--- palm/trunk/SCRIPTS/palm_gf_files/palm_gf_tools.py	(revision 4480)
+++ palm/trunk/SCRIPTS/palm_gf_files/palm_gf_tools.py	(revision 4481)
@@ -15,5 +15,5 @@
 # PALM. If not, see <http://www.gnu.org/licenses/>.
 #
-# Copyright 1997-2018  Leibniz Universitaet Hannover
+# Copyright 1997-2020  Leibniz Universitaet Hannover
 #--------------------------------------------------------------------------------#
 #
Index: palm/trunk/SCRIPTS/palm_simple_build
===================================================================
--- palm/trunk/SCRIPTS/palm_simple_build	(revision 4480)
+++ palm/trunk/SCRIPTS/palm_simple_build	(revision 4481)
@@ -14,5 +14,5 @@
 # PALM. If not, see <http://www.gnu.org/licenses/>.
 #
-# Copyright 1997-2018  Leibniz Universitaet Hannover
+# Copyright 1997-2020  Leibniz Universitaet Hannover
 #--------------------------------------------------------------------------------#
 #
Index: palm/trunk/SCRIPTS/palm_simple_run
===================================================================
--- palm/trunk/SCRIPTS/palm_simple_run	(revision 4480)
+++ palm/trunk/SCRIPTS/palm_simple_run	(revision 4481)
@@ -14,5 +14,5 @@
 # PALM. If not, see <http://www.gnu.org/licenses/>.
 #
-# Copyright 1997-2018  Leibniz Universitaet Hannover
+# Copyright 1997-2020  Leibniz Universitaet Hannover
 #--------------------------------------------------------------------------------#
 #
Index: palm/trunk/SCRIPTS/palm_wd
===================================================================
--- palm/trunk/SCRIPTS/palm_wd	(revision 4480)
+++ palm/trunk/SCRIPTS/palm_wd	(revision 4481)
@@ -15,5 +15,5 @@
 # PALM. If not, see <http://www.gnu.org/licenses/>.
 #
-# Copyright 1997-2018  Leibniz Universitaet Hannover
+# Copyright 1997-2020  Leibniz Universitaet Hannover
 #--------------------------------------------------------------------------------#
 #
Index: palm/trunk/SCRIPTS/palm_wdd
===================================================================
--- palm/trunk/SCRIPTS/palm_wdd	(revision 4480)
+++ palm/trunk/SCRIPTS/palm_wdd	(revision 4481)
@@ -15,5 +15,5 @@
 # PALM. If not, see <http://www.gnu.org/licenses/>.
 #
-# Copyright 1997-2018  Leibniz Universitaet Hannover
+# Copyright 1997-2020  Leibniz Universitaet Hannover
 #--------------------------------------------------------------------------------#
 #
Index: palm/trunk/SCRIPTS/palmbuild
===================================================================
--- palm/trunk/SCRIPTS/palmbuild	(revision 4480)
+++ palm/trunk/SCRIPTS/palmbuild	(revision 4481)
@@ -17,5 +17,5 @@
 # PALM. If not, see <http://www.gnu.org/licenses/>.
 #
-# Copyright 2017-2018  Leibniz Universitaet Hannover
+# Copyright 2017-2020  Leibniz Universitaet Hannover
 #------------------------------------------------------------------------------#
 #
Index: palm/trunk/SCRIPTS/palmplot
===================================================================
--- palm/trunk/SCRIPTS/palmplot	(revision 4480)
+++ palm/trunk/SCRIPTS/palmplot	(revision 4481)
@@ -14,5 +14,5 @@
 # PALM. If not, see <http://www.gnu.org/licenses/>.
 #
-# Copyright 1997-2018  Leibniz Universitaet Hannover
+# Copyright 1997-2020  Leibniz Universitaet Hannover
 #--------------------------------------------------------------------------------#
 #
Index: palm/trunk/SCRIPTS/palmrun
===================================================================
--- palm/trunk/SCRIPTS/palmrun	(revision 4480)
+++ palm/trunk/SCRIPTS/palmrun	(revision 4481)
@@ -17,5 +17,5 @@
 # PALM. If not, see <http://www.gnu.org/licenses/>.
 #
-# Copyright 2017-2018  Leibniz Universitaet Hannover
+# Copyright 2017-2020  Leibniz Universitaet Hannover
 #--------------------------------------------------------------------------------#
 #
Index: palm/trunk/SCRIPTS/palmrungui
===================================================================
--- palm/trunk/SCRIPTS/palmrungui	(revision 4480)
+++ palm/trunk/SCRIPTS/palmrungui	(revision 4481)
@@ -15,5 +15,5 @@
 # PALM. If not, see <http://www.gnu.org/licenses/>.
 #
-# Copyright 1997-2018  Leibniz Universitaet Hannover
+# Copyright 1997-2020  Leibniz Universitaet Hannover
 #--------------------------------------------------------------------------------#
 #
@@ -25,4 +25,8 @@
 # -----------------
 # $Id$
+# Bugfixes: - reading history lines discard button caused error message
+#           - deleting of USER_CODE files did not work
+# 
+# 4470 2020-03-24 06:52:19Z maronga
 # Added file size output, more I/O functionalities, new/removed buttons
 # 
@@ -1112,30 +1116,31 @@
        opt.exec_()
 
-       palmrunline = str(history_entry)
-       palmrunline = palmrunline[17:]
-       palmrunline = palmrunline[:len(palmrunline)-1]
-       palmrunline = filter(None,palmrunline.split("("))[0]
-       self.groupBox.findChild(QtGui.QLineEdit,"commandline").setText(palmrunline)
-
-#      Set selected item to jobname in "available jobs" list
-       jobname = str(history_entry[17:])
-       jobname = filter(None,jobname.split(" -r"))[1]
-       jobname = jobname.strip()
-       jobname = filter(None,jobname.split(" "))[0]
-       jobname = jobname.replace("\"","") 
-       item2int = self.list_jobs.findItems(jobname,QtCore.Qt.MatchCaseSensitive)
-
-       if ( item2int != [] ):
-          self.list_jobs.setCurrentItem(item2int[0])
-          self.update_input()
-
-#      Add tooltip tag
-       tag = str(history_entry).split('\n')[0]
-       tag = filter(None,tag.split("("))[1]
-       tag = tag.replace(")","")
-       self.groupBox.findChild(QtGui.QLineEdit,"line_tag").setText(tag)
+       if ( history_entry != "" ):
+          palmrunline = str(history_entry)
+          palmrunline = palmrunline[17:]
+          palmrunline = palmrunline[:len(palmrunline)-1]
+          palmrunline = filter(None,palmrunline.split("("))[0]
+          self.groupBox.findChild(QtGui.QLineEdit,"commandline").setText(palmrunline)
+
+#         Set selected item to jobname in "available jobs" list
+          jobname = str(history_entry[17:])
+          jobname = filter(None,jobname.split(" -r"))[1]
+          jobname = jobname.strip()
+          jobname = filter(None,jobname.split(" "))[0]
+          jobname = jobname.replace("\"","")
+          item2int = self.list_jobs.findItems(jobname,QtCore.Qt.MatchCaseSensitive)
+
+          if ( item2int != [] ):
+             self.list_jobs.setCurrentItem(item2int[0])
+             self.update_input()
+
+#         Add tooltip tag
+          tag = str(history_entry).split('\n')[0]
+          tag = filter(None,tag.split("("))[1]
+          tag = tag.replace(")","")
+          self.groupBox.findChild(QtGui.QLineEdit,"line_tag").setText(tag)
  
-#      Process palmrungui to set up gui controls
-       self.setup_gui(palmrunline)
+#         Process palmrungui to set up gui controls
+          self.setup_gui(palmrunline)
 
 
@@ -1606,5 +1611,5 @@
           sel_files = self.list_user.selectedItems()
 
-          input_dir = job_dir + "/" + sel_job + "/USER/"
+          input_dir = job_dir + "/" + sel_job + "/USER_CODE/"
 
           for i in range(0,len(sel_files)):
@@ -1745,5 +1750,6 @@
     def DiscardHistory(self):
 
-
+       global history_entry
+       history_entry = ""
        self.close()
 
Index: palm/trunk/SCRIPTS/process_dvr_output
===================================================================
--- palm/trunk/SCRIPTS/process_dvr_output	(revision 4480)
+++ palm/trunk/SCRIPTS/process_dvr_output	(revision 4481)
@@ -14,5 +14,5 @@
 # PALM. If not, see <http://www.gnu.org/licenses/>.
 #
-# Copyright 1997-2018  Leibniz Universitaet Hannover
+# Copyright 1997-2020  Leibniz Universitaet Hannover
 #--------------------------------------------------------------------------------#
 #
Index: palm/trunk/SCRIPTS/release_tutorial
===================================================================
--- palm/trunk/SCRIPTS/release_tutorial	(revision 4480)
+++ palm/trunk/SCRIPTS/release_tutorial	(revision 4481)
@@ -14,5 +14,5 @@
 # PALM. If not, see <http://www.gnu.org/licenses/>.
 #
-# Copyright 1997-2018  Leibniz Universitaet Hannover
+# Copyright 1997-2020  Leibniz Universitaet Hannover
 #--------------------------------------------------------------------------------#
 #