Index: palm/trunk/UTIL/inifor/tests/test-reverse-even.f90
===================================================================
--- palm/trunk/UTIL/inifor/tests/test-reverse-even.f90	(revision 4499)
+++ palm/trunk/UTIL/inifor/tests/test-reverse-even.f90	(revision 4499)
@@ -0,0 +1,75 @@
+!> @file tests/test-prototype.f90
+!------------------------------------------------------------------------------!
+! This file is part of the PALM model system.
+!
+! PALM is free software: you can redistribute it and/or modify it under the
+! terms of the GNU General Public License as published by the Free Software
+! Foundation, either version 3 of the License, or (at your option) any later
+! version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
+! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
+! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with
+! PALM. If not, see <http://www.gnu.org/licenses/>.
+!
+! Copyright 2017-2020 Leibniz Universitaet Hannover
+! Copyright 2017-2020 Deutscher Wetterdienst Offenbach
+!------------------------------------------------------------------------------!
+!
+! Current revisions:
+! -----------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id: test-prototype.f90 4481 2020-03-31 18:55:54Z maronga $
+! Added usage hints
+! 
+! 3182 2018-07-27 13:36:03Z suehring
+! Initial revision
+!
+! 
+!
+! Authors:
+! --------
+! @author Eckhard Kadasch
+!
+! Description:
+! ------------
+!> This prototype test does nothing, but serves as a template for programming
+!> new INIFOR tests.
+!------------------------------------------------------------------------------!
+ PROGRAM test_reverse_even
+
+    USE inifor_defs,                                                           &
+        ONLY :  wp
+
+    USE inifor_util,                                                           &
+        ONLY :  reverse
+
+    USE test_utils
+    
+    IMPLICIT NONE
+
+    CHARACTER(LEN=*), PARAMETER ::  title = "array reversion even no of elements"
+    LOGICAL                     ::  res
+
+    REAL(wp), DIMENSION(1,1,4) :: array, reversed_array
+
+    CALL begin_test(title, res)
+
+    ! Arange
+    array(1,1,:) = (/1.0_wp, 2.0_wp, 3.0_wp, 4.0_wp/)
+    reversed_array(1,1,:) = (/4.0_wp, 3.0_wp, 2.0_wp, 1.0_wp/)
+
+    ! Act
+    CALL reverse(array)
+
+    ! Assert
+    res = res .AND. assert_equal(array(1,1,:), reversed_array(1,1,:), 'reversed array')
+
+    CALL end_test(title, res)
+    
+ END PROGRAM test_reverse_even
Index: palm/trunk/UTIL/inifor/tests/test-reverse-odd.f90
===================================================================
--- palm/trunk/UTIL/inifor/tests/test-reverse-odd.f90	(revision 4499)
+++ palm/trunk/UTIL/inifor/tests/test-reverse-odd.f90	(revision 4499)
@@ -0,0 +1,75 @@
+!> @file tests/test-prototype.f90
+!------------------------------------------------------------------------------!
+! This file is part of the PALM model system.
+!
+! PALM is free software: you can redistribute it and/or modify it under the
+! terms of the GNU General Public License as published by the Free Software
+! Foundation, either version 3 of the License, or (at your option) any later
+! version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
+! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
+! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with
+! PALM. If not, see <http://www.gnu.org/licenses/>.
+!
+! Copyright 2017-2020 Leibniz Universitaet Hannover
+! Copyright 2017-2020 Deutscher Wetterdienst Offenbach
+!------------------------------------------------------------------------------!
+!
+! Current revisions:
+! -----------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id: test-prototype.f90 4481 2020-03-31 18:55:54Z maronga $
+! Added usage hints
+! 
+! 3182 2018-07-27 13:36:03Z suehring
+! Initial revision
+!
+! 
+!
+! Authors:
+! --------
+! @author Eckhard Kadasch
+!
+! Description:
+! ------------
+!> This prototype test does nothing, but serves as a template for programming
+!> new INIFOR tests.
+!------------------------------------------------------------------------------!
+ PROGRAM test_reverse_odd
+
+    USE inifor_defs,                                                           &
+        ONLY :  wp
+
+    USE inifor_util,                                                           &
+        ONLY :  reverse
+
+    USE test_utils
+    
+    IMPLICIT NONE
+
+    CHARACTER(LEN=*), PARAMETER ::  title = "array reversion odd no of elements"
+    LOGICAL                     ::  res
+
+    REAL(wp), DIMENSION(1,1,5) :: array, reversed_array
+
+    CALL begin_test(title, res)
+
+    ! Arange
+    array(1,1,:) = (/1.0_wp, 2.0_wp, 3.0_wp, 4.0_wp, 5.0_wp/)
+    reversed_array(1,1,:) = (/5.0_wp, 4.0_wp, 3.0_wp, 2.0_wp, 1.0_wp/)
+
+    ! Act
+    CALL reverse(array)
+
+    ! Assert
+    res = res .AND. assert_equal(array(1,1,:), reversed_array(1,1,:), 'reversed array')
+
+    CALL end_test(title, res)
+    
+ END PROGRAM test_reverse_odd
Index: palm/trunk/UTIL/inifor/tests/test-stretching.f90
===================================================================
--- palm/trunk/UTIL/inifor/tests/test-stretching.f90	(revision 4481)
+++ palm/trunk/UTIL/inifor/tests/test-stretching.f90	(revision 4499)
@@ -26,4 +26,8 @@
 ! -----------------
 ! $Id$
+! Bugfix: carry over variable name change of 'dp' to 'wp'
+! 
+! 
+! 
 ! Prefixed all INIFOR modules with inifor_
 ! 
@@ -48,5 +52,5 @@
 
     USE inifor_defs,                                                           &
-        ONLY :  dp
+        ONLY :  wp
 
     USE inifor_grid,                                                           &
@@ -63,18 +67,18 @@
     INTEGER            ::  k  = nz - 2
 
-    REAL(dp) ::  z(1:nz)
-    REAL(dp) ::  dz(10)            = -1.0_dp
-    REAL(dp) ::  dz_max            = 1000.0_dp
-    REAL(dp) ::  dz_stretch_factor = 1.08_dp
-    REAL(dp) ::  dz_stretch_level  = 2.0_dp
-    REAL(dp) ::  dz_stretch_level_start(9) = -9999999.9_dp
-    REAL(dp) ::  dz_stretch_level_end(9) = 9999999.9_dp
-    REAL(dp) ::  dz_stretch_factor_array(9) = 1.08_dp
+    REAL(wp) ::  z(1:nz)
+    REAL(wp) ::  dz(10)            = -1.0_wp
+    REAL(wp) ::  dz_max            = 1000.0_wp
+    REAL(wp) ::  dz_stretch_factor = 1.08_wp
+    REAL(wp) ::  dz_stretch_level  = 2.0_wp
+    REAL(wp) ::  dz_stretch_level_start(9) = -9999999.9_wp
+    REAL(wp) ::  dz_stretch_level_end(9) = 9999999.9_wp
+    REAL(wp) ::  dz_stretch_factor_array(9) = 1.08_wp
 
     CALL begin_test(title, res)
 
     ! Arange
-    z(:)   = 0.0_dp
-    dz(1)  = 1.0_dp
+    z(:)   = 0.0_wp
+    dz(1)  = 1.0_wp
 
     ! Act
@@ -96,6 +100,6 @@
     res = res .AND. &
           assert_equal( (/ z(UBOUND(z, 1)) - z(1)              /),             &
-                        (/ (1.0_dp - dz_stretch_factor**(k+1)) /               &
-                           (1.0_dp - dz_stretch_factor)        /),             &
+                        (/ (1.0_wp - dz_stretch_factor**(k+1)) /               &
+                           (1.0_wp - dz_stretch_factor)        /),             &
                         'length of stretched grid' )
 